/******************************************************************************
BandasRegMulti.java

Direitos Autorais Reservados (c) 2009 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob
os termos da Licena Pblica Geral GNU conforme publicada pela Free Software
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais 
detalhes.

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
Temple Street, Suite 330, Boston, MA 02111-1307 USA.

********************************************************************************

Parte integrante do software 'Sofia Imagens - SOFtware Inteligente de Anlise 
                                              de Imagens'.

Este fonte faz parte do livro:

	Processamento de Imagens Digitais: Mtodos Multivariados em Java.
	Jos Iguelmar Miranda.
	Embrapa Informtica Agropecuria.
	Campinas, maio de 2009.

Descrio:

	Seleciona bandas para regresso mltipla
	Classe para iniciar o processo de regresso linear mltipla entre bandas.
	Esta classe chama a classe RegressMultipla, que efetivamente realiza a
	regresso mltipla (ver RegressMultipla.java).

Entrada:

  Caminho do diretrio dos arquivos (path) e nome dos arquivos com as
	imagens (bandas).

Sada:

	Chamada para a classe RegressMultipla.

Desenvolvido por:

    Jos Iguelmar Miranda

Informaes do CVS:
       $Source$:
       $Revision$:
       $Date$:

******************************************************************************/

package pID;

// Pacotes genricos
import java.io.File;
import java.util.Vector;

// Pacotes do AWT
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.GridLayout;
import java.awt.image.Raster;
import java.awt.event.ActionEvent;
import java.awt.image.BufferedImage;
import java.awt.event.ActionListener;

// Pacote Swing para interface grfica
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.ButtonGroup;
import javax.swing.JOptionPane;
import javax.swing.JRadioButton;

// Leitura em modo imediato - para J2SE 1.4+
import javax.imageio.ImageIO;

public class BandasRegMulti {

	// ATRIBUTOS DA CLASSE
	//
	private static int x[][], y[];

	// CONSTRUTOR
	//
	public BandasRegMulti(final String[] _path, String[] _nomeArquivos) {

		int nA;

		final JFrame frame = new JFrame("Regresso Mltipla");
		JRadioButton[] rbuttonArquivo;
		JButton buttonOK, buttonCancel;
		JCheckBox[] checkboxVarIndep;
		final JPanel panelVarDependente, panelVarIndependente, panelBotoes;
		final ButtonGroup bgroupVarDep;

		nA = _nomeArquivos.length;
		rbuttonArquivo = new JRadioButton[nA];

		panelVarDependente = new JPanel();
		bgroupVarDep = new ButtonGroup();
		for (int i = 0; i < nA; i++) {
			panelVarDependente.add(rbuttonArquivo[i] = 
															new JRadioButton(_nomeArquivos[i]));
			rbuttonArquivo[i].setActionCommand(_nomeArquivos[i]);
			bgroupVarDep.add(rbuttonArquivo[i]);
		}
		
		panelVarIndependente = new JPanel();
		checkboxVarIndep = new JCheckBox[nA];
		for (int i = 0; i < nA; i++) {
			panelVarIndependente.add(checkboxVarIndep[i] = 
																			new JCheckBox(_nomeArquivos[i]));
			checkboxVarIndep[i].setActionCommand(_nomeArquivos[i]);
			panelVarIndependente.add(checkboxVarIndep[i]);
		}

		panelBotoes = new JPanel();
		buttonOK = new JButton("OK");
		panelBotoes.add(buttonOK);
		buttonCancel = new JButton("Cancela");
		panelBotoes.add(buttonCancel);

		Container cPaineis = frame.getContentPane();
		cPaineis.setLayout(new GridLayout(3, 1));
		cPaineis.add(panelVarDependente);
		cPaineis.add(panelVarIndependente);
		cPaineis.add(panelBotoes);

		buttonOK.addActionListener(new ActionListener() {
			String yArquivo, xArquivo;
			Vector vecxArquivo;
			public void actionPerformed(ActionEvent ae) {
				yArquivo = bgroupVarDep.getSelection().getActionCommand();
				System.out.println("var dep = "+yArquivo);
				Component[] varIndep = panelVarIndependente.getComponents();
				vecxArquivo = new Vector();
				for (int i = 0; i < varIndep.length; i++)	{
					JCheckBox checkArq = (JCheckBox)varIndep[i];
					if (checkArq.isSelected()) {
						xArquivo = checkArq.getText();
						vecxArquivo.addElement(xArquivo);
						System.out.println("var indep = "+ xArquivo);
					}
				}
				frame.setVisible(false);
				abreArquivos(_path, vecxArquivo, yArquivo);
				new RegressMultipla(x, y);
			}
		});

		buttonCancel.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				frame.setVisible(false);
			}
		});		
		frame.setSize(200, 300);
		frame.setVisible(true);
		panelBotoes.setBorder(BorderFactory.createLineBorder(Color.black));
		panelVarDependente.setBorder(BorderFactory.createLineBorder(Color.black));
		panelVarIndependente.setBorder(BorderFactory.createLineBorder(Color.black));
	}

	// MTODOS PRIVADOS
	//
	private void abreArquivos(String[] _path, Vector _xArquivo, String _yArquivo) {

		// Define array com espao para os n _xArquivo
		//
		String arquivo;
		BufferedImage[] srcX;
		BufferedImage srcY = null;
		Raster srcRY, srcRX;
		File file;
		int indice, altura, largura, xV;

		// Define atributo xV = nmero de variveis independentes
		//
		xV = _xArquivo.size();
		srcX = new BufferedImage[xV];

		// Abre arquivos como variveis independentes
		//
		for (int i = 0; i < xV; i++) {
			arquivo = _path[0] + "\\" + _xArquivo.elementAt(i);

	    // Certifica que as imagens existem
			//
		  file = new File(arquivo);
			try {
				srcX[i] = ImageIO.read(file);
			} catch(Exception e) {
				String msg = "Imagem '" + file + "' no existe";
				String titulo = "Regresso Mltipla";
				JOptionPane.showMessageDialog(null, msg, titulo, 0);
			}
		}

		// Abre arquivo como varivel dependente
		//
		arquivo = _path[0] + "\\" + _yArquivo;

    // Certifica que as imagens existem
		//
	  file = new File(arquivo);
		try {
			srcY = ImageIO.read(file);
		} catch(Exception e) {
			String msg = "Imagem '" + file + "' no existe";
			String titulo = "Regresso Mltipla";
			JOptionPane.showMessageDialog(null, msg, titulo, 0);
		}

		// Armazena os pixels da varivel dependente
		//
		srcRY = srcY.getRaster();
		altura = srcY.getHeight();
		largura = srcY.getWidth();
		y = new int[altura*largura];

	  for (int i = 0; i < altura; i++)
			for (int j = 0; j < largura; j++) {
				indice = i*largura + j;
				y[indice] = srcRY.getSample(j, i, 0);
			}

		// Armazena os pixels das variveis independentes
		//
		x = new int[xV][altura*largura];
		for (int v = 0; v < xV; v++) {
			srcRX = srcX[v].getRaster();
			for (int i = 0; i < altura; i++)
				for (int j = 0; j < largura; j++) {
					indice = i*largura + j;
					x[v][indice] = srcRX.getSample(j, i, 0);
				}
		}
	}
}
