/******************************************************************************
EscolheBandas.java

Direitos Autorais Reservados (c) 2009 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob
os termos da Licena Pblica Geral GNU conforme publicada pela Free Software
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais 
detalhes.

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
Temple Street, Suite 330, Boston, MA 02111-1307 USA.

********************************************************************************

Parte integrante do software 'Sofia Imagens - SOFtware Inteligente de Anlise 
                                              de Imagens'.

Este fonte faz parte do livro:

	Processamento de Imagens Digitais: Mtodos Multivariados em Java.
	Jos Iguelmar Miranda.
	Embrapa Informtica Agropecuria.
	Campinas, maio de 2009.

Descrio:

 Faz escolha das bandas a serem combinadas numa lista.
  
Entrada:

 Uma lista com os nomes das bandas abertas.

Sada:

 Um array com o nome das bandas escolhidas.
 Aps o usurio escolher as trs bandas e acionar o boto "OK",
 a classe FalsaCor  chamada, passando essas bandas. Essa imagem em falsa
 cor ser usada para a escolha das reas de treinamento.

Desenvolvido por:

    Jos Iguelmar Miranda

Informaes do CVS:
       $Source$:
       $Revision$:
       $Date$:

******************************************************************************/

package pID;

// Pacotes AWT event
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

// Pacotes do AWT
import java.awt.BorderLayout;

// Pacotes Swing
import javax.swing.Box;
import javax.swing.JList;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JButton;
import javax.swing.JButton;
import javax.swing.BoxLayout;
import javax.swing.JSeparator;
import javax.swing.JComponent;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.BorderFactory;
import javax.swing.SwingConstants;
import javax.swing.DefaultListModel;
import javax.swing.ListSelectionModel;

// Pacotes Swing event
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

public class EscolheBandas extends JPanel implements ListSelectionListener {

	// ATRIBUTOS
	//
	private static JFrame frame;
		
	private JList list;
  private DefaultListModel listModel;

  private static final String okString = "OK";
  private static final String fireString = "Seleciona";
  private static final String cancelString = "Cancela";
  private JButton fireButton, cancelButton, okButton;
	private String[] bandasEscolhidas, pathBandas;
	private int nb = 0;

  // CONSTRUTOR
	//
  public EscolheBandas(String[] path, String[] bandas) {
		super(new BorderLayout());
		
		int nBandas;

    frame = new JFrame("EscolheBandas");
			
    // Condies para mostrar o painel
		//
		this.setOpaque(true);
		frame.setContentPane(this);
    frame.setSize(300, 200);
    frame.setVisible(true);

    listModel = new DefaultListModel();

		// Cria lista com nomes de bandas
		//
		nBandas = bandas.length;
		bandasEscolhidas = new String[nBandas];
		pathBandas = path;
		System.out.println("Construtor::nBandas = " + nBandas);
		for (int i = 0; i < nBandas; i++) {
	    listModel.addElement(bandas[i]);
		}

    // Cria uma lista e a coloca em JScrollPane
		//
    list = new JList(listModel);
    list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION );
    list.setSelectedIndex(0);
    list.addListSelectionListener(this);
    list.setVisibleRowCount(5);
    JScrollPane listScrollPane = new JScrollPane(list);

		// Ao para OK
		//
    okButton = new JButton(okString);
    okButton.setActionCommand(okString);
    okButton.addActionListener(new OKListener());

		// Ao para cancelar
		//
    cancelButton = new JButton(cancelString);
    cancelButton.setActionCommand(cancelString);
    cancelButton.addActionListener(new CancelListener());

		// Ao para selecionar bandas
		//
    fireButton = new JButton(fireString);
    fireButton.setActionCommand(fireString);
    fireButton.addActionListener(new FireListener());

    // Cria um painel que usa BoxLayout.
		//
    JPanel buttonPane = new JPanel();
    buttonPane.setLayout(new BoxLayout(buttonPane,
                             BoxLayout.LINE_AXIS));
    buttonPane.add(fireButton);
    buttonPane.add(Box.createHorizontalStrut(5));
    buttonPane.add(new JSeparator(SwingConstants.VERTICAL));
    buttonPane.add(Box.createHorizontalStrut(5));
    buttonPane.add(okButton);

    buttonPane.add(new JSeparator(SwingConstants.VERTICAL));
    buttonPane.add(Box.createHorizontalStrut(5));
    buttonPane.add(cancelButton);
		buttonPane.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));

    add(listScrollPane, BorderLayout.CENTER);
    add(buttonPane, BorderLayout.PAGE_END);
  }

	// Listener para ao Seleciona
	//
	class FireListener implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			int index = list.getSelectedIndex();
			System.out.println(listModel.getElementAt(index));
			if (nb < 3) {
				bandasEscolhidas[nb] = listModel.getElementAt(index).toString();
				nb++;
			} else {
				String msg = "Nmero de bandas excedeu 3!";
				String titulo = "Escolhe bandas";
				JOptionPane.showMessageDialog(null, msg, titulo, 0);
			}
    }
  }

	// Listener para ao de OK
	//
	class OKListener implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			System.out.println("\nConstrutor::OK bandas escolhidas");
			for (int i = 0; i < bandasEscolhidas.length; i++) {
			  System.out.println(bandasEscolhidas[i]);
			}
			new FalsaCor(pathBandas, bandasEscolhidas);
			frame.dispose();
    }
  }

	// Listener para ao de cancelar
	//
	class CancelListener implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			frame.dispose();
    }
  }

  // Mtodo requerido por ListSelectionListener.
  public void valueChanged(ListSelectionEvent e) {
		if (e.getValueIsAdjusting() == false) {
      if (list.getSelectedIndex() == -1) {

        // Sem seleo, disable fireButton.
				//
        fireButton.setEnabled(false);
      } else {

        // Seleo, enable fireButton.
        fireButton.setEnabled(true);
      }
		}
	}

}
