/******************************************************************************
EscolheImagem.java

Direitos Autorais Reservados (c) 2009 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob
os termos da Licena Pblica Geral GNU conforme publicada pela Free Software
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais 
detalhes.

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
Temple Street, Suite 330, Boston, MA 02111-1307 USA.

********************************************************************************

Parte integrante do software 'Sofia Imagens - SOFtware Inteligente de Anlise 
                                              de Imagens'.

Este fonte faz parte do livro:

	Processamento de Imagens Digitais: Mtodos Multivariados em Java.
	Jos Iguelmar Miranda.
	Embrapa Informtica Agropecuria.
	Campinas, maio de 2009.

Descrio:

 Classe para escolha de imagens j abertas na opo
 'Arquivo -> Abrir'.
 Esse objeto permite o uso de uma lista de imagens usando
 um JCheckBox.
  
Entrada:

 Uma lista com os nomes das bandas abertas.

Sada:

 Uma lista com as bandas escolhidas.

Desenvolvido por:

    Jos Iguelmar Miranda

Informaes do CVS:
       $Source$:
       $Revision$:
       $Date$:

******************************************************************************/

package pID;

// Pacote genrico
import java.util.Vector;

// Pacotes do Swing
import javax.swing.JRadioButton;
import javax.swing.ButtonGroup;
import javax.swing.JCheckBox;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;

// Pacotes do AWT
import java.awt.Container;
import java.awt.Component;
import java.awt.GridLayout;
import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class EscolheImagem {

	// ATRIBUTOS

	// Varivel imagem para mtodo univariado
	//
	public String imagemEscolhida;
		
	// Varivel imagem para mtodo multivariado
	//
	public String[] imagensEscolhidas;

	// Varivel para armazenar indice das imagens escolhidas - 
	// mtodo multivariado
	//
	public int[] indiceImagensEscolhidas;
		
	// CONSTRUTOR PARA MTODO MULTIVARIADO
	//
  public EscolheImagem(String[] strImagens) {

		int comp = strImagens.length;
		indiceImagensEscolhidas = new int[strImagens.length];
		final Vector escolhidas = new Vector();

		final JFrame controllerFrame = new JFrame("Escolhe Imagem");
		final JPanel imagensPanel = new JPanel();
		imagensPanel.setLayout(new GridLayout(comp, 1));
		for (int i = 0; i < comp; i++) {
			imagensPanel.add(new JCheckBox(strImagens[i]));
		}

		JPanel escolhaPanel = new JPanel();
		JButton escolhaButton = new JButton("OK");
		escolhaPanel.add(escolhaButton);

		Container content = controllerFrame.getContentPane();
		content.setLayout(new BorderLayout());
		content.add(imagensPanel, BorderLayout.NORTH);
		content.add(escolhaPanel, BorderLayout.CENTER);
		escolhaButton.addActionListener(new ActionListener() {
			int j = 0;
			public void actionPerformed(ActionEvent ae) {
				Component[] components = imagensPanel.getComponents();
				for (int k = 0; k < components.length; k++)	{
					JCheckBox cb = (JCheckBox)components[k];
					if (cb.isSelected())	{
						System.out.println("EscolheImagem <construtor#1> (if): " + cb.getText());
						escolhidas.addElement(cb.getText());

						// Armazena indice das imagens escolhidas
						//
						indiceImagensEscolhidas[j++] = k;
					}
				}
				imagensEscolhidas = new String[escolhidas.size()];
				for (int i = 0; i < escolhidas.size(); i++)	{
					imagensEscolhidas[i] = (String)escolhidas.elementAt(i);
					System.out.println("EscolheImagem <construtor#1>: " + imagensEscolhidas[i]);
				}

				// Imagens foram escolhidas; fecha janela JCheckBox
				//
				controllerFrame.setVisible(false);
			}
		});
		controllerFrame.setSize(200, 150);
		controllerFrame.setVisible(true);
	}

	// CONSTRUTOR PARA MTODO UNIVARIADO

	public EscolheImagem(String[] strImagens, int single) { 

		int comp = strImagens.length;

		final JFrame controllerFrame = new JFrame("Escolhe Imagem");

		JPanel imagemPanel = new JPanel();
		final ButtonGroup imagemGroup = new ButtonGroup();
		JRadioButton radioButton;
		imagemPanel.setLayout(new GridLayout(comp, 1));
		for (int i = 0; i < comp; i++) {
			imagemPanel.add(radioButton = new JRadioButton(strImagens[i]));
			radioButton.setActionCommand(strImagens[i]);
			imagemGroup.add(radioButton);
		}

		JPanel escolhaPanel = new JPanel();
		JButton escolhaButton = new JButton("OK");
		escolhaPanel.add(escolhaButton);

		Container content = controllerFrame.getContentPane();
		content.setLayout(new BorderLayout());
		content.add(imagemPanel, BorderLayout.NORTH);
		content.add(escolhaPanel, BorderLayout.CENTER);

		escolhaButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				imagemEscolhida = imagemGroup.getSelection().getActionCommand();
				System.out.println("EscolheImagem <construtor#2>: " + imagemEscolhida);

				// Imagens foram escolhidas; fecha janela JCheckBox
				//
				controllerFrame.setVisible(false);
			}
		});
		controllerFrame.setSize(200, 150);
		controllerFrame.setVisible(true);
  }
}
