/******************************************************************************
ImagemROI.java

Esta classe foi adaptada do seguinte autor:
	@author Rahul Sapkal(rahul@javareference.com)

********************************************************************************

Parte integrante do software 'Sofia Imagens - SOFtware Inteligente de Anlise 
                                              de Imagens'.

Este fonte faz parte do livro:

	Processamento de Imagens Digitais: Mtodos Multivariados em Java.
	Jos Iguelmar Miranda.
	Embrapa Informtica Agropecuria.
	Campinas, maio de 2009.

Descrio:

Entrada:

Sada:

Desenvolvido por:

Informaes do CVS:
       $Source$:
       $Revision$:
       $Date$:

******************************************************************************/

package pID;

// Pacotes genricos
import java.util.Vector;

import java.io.IOException;
import java.io.FileWriter;
import java.io.BufferedWriter;

// Pacotes do AWT
import java.awt.Point;
import java.awt.Color;
import java.awt.Image;
import java.awt.Cursor;
import java.awt.Toolkit;
import java.awt.Graphics;
import java.awt.Dimension;
import java.awt.Graphics2D;
import java.awt.image.Raster;
import java.awt.FlowLayout;
import java.awt.geom.Line2D;
import java.awt.BorderLayout;
import java.awt.geom.Ellipse2D;
import java.awt.geom.GeneralPath;
import java.awt.geom.Rectangle2D;
import java.awt.image.BufferedImage;
import java.awt.image.WritableRaster;

// Pacotes com eventos
import java.awt.event.MouseListener;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.MouseEvent;

// Pacotes do Swing
import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.JButton;
import javax.swing.JMenu;
import javax.swing.ImageIcon;
import javax.swing.JViewport;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JOptionPane;
import javax.swing.JDesktopPane;
import javax.swing.JInternalFrame;
import javax.swing.table.TableModel;
import javax.swing.table.TableColumn;
import javax.swing.ListSelectionModel;
import javax.swing.table.DefaultTableModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.AbstractTableModel;

public class ImagemROI extends JInternalFrame 
       implements MouseListener, ActionListener {

		// ATRIBUTOS

		public int bandas;
    private int tipoEvento;
		private double m_zoom = 1.0;
		private String tipoFrame = null;
		private String coordenadas = "";
		private boolean zoomFlag = false;
		private static int openFrameCount = 0;
		private static final int xOffset = 30, yOffset = 30;
		private ImagePanel m_imagePanel;

		private JScrollPane m_srollPane;
    private JPanel m_imageContainer;
    private JLabel m_zoomedInfo;
    private JButton m_zoomInButton;
    private JButton m_zoomOutButton;
    private JButton m_originalButton;
    private Cursor m_zoomCursor;
		private JDesktopPane desk;
		private JPopupMenu popup = null;
		private JScrollPane scrollPane;
		private JLabel imgL1;
		private JTable tabelaROI;
		private DefaultTableModel modeloTabela;

		private Vector vetorROI;
		private Vector vetorTemas;

		private BufferedImage imagemOrig;
		private BufferedImage imagemTemp;
		  
		// CONSTRUTOR DA CLASSE

    public ImagemROI(BufferedImage img, double zoomPercentage, String nomeImagem,
			JDesktopPane desktmp) {

				super("Imagem  [" + nomeImagem + "]", 
           true,					// resizable
           true,					// closable
           true,					// maximizable
           true);					// iconifiable
        
				setSize(600,450);
				tipoEvento = 0;
				desk = desktmp;
				if (img == null) {
            add(new JLabel("Imagem '" + nomeImagem + "' no encontrada."));
        }
        else {
						bandas = img.getSampleModel().getNumBands();
						vetorROI = new Vector();
						vetorTemas = new Vector();
						imagemOrig = img;
						if (bandas == 3) {
							WritableRaster destWR = img.copyData(null); 
							imagemTemp = new BufferedImage(img.getColorModel(), destWR, false, null);
						} else {
							Raster srcR = img.getRaster();
							int w = img.getWidth();
							int h = img.getHeight();
							int tipo = BufferedImage.TYPE_3BYTE_BGR;
							imagemTemp = new BufferedImage(w, h, tipo);
							WritableRaster destWR1 = imagemTemp.getRaster();	
							for (int i = 0; i < h; i++)
								for (int j = 0; j < w; j++) {
									destWR1.setSample(j, i, 0, srcR.getSample(j, i, 0));
									destWR1.setSample(j, i, 1, srcR.getSample(j, i, 0));
									destWR1.setSample(j, i, 2, srcR.getSample(j, i, 0));
								}							
						}
						Image imagem = new ImageIcon(imagemTemp).getImage();
            JPanel topPanel = new JPanel(new FlowLayout(FlowLayout.CENTER));
						JPanel tablePanel = new JPanel(new FlowLayout(FlowLayout.CENTER));

            //-------Table------------------
						//
						String[] columnNames = {"Tema", "# Tema", "# Pixels"};
						modeloTabela = new DefaultTableModel(columnNames, 0); 
						tabelaROI = new JTable(modeloTabela);

						ListSelectionModel rowSM = tabelaROI.getSelectionModel();
						rowSM.addListSelectionListener(new ListSelectionListener() {
						public void valueChanged(ListSelectionEvent e) {

							// Ignore extra messages.
							//
							if (e.getValueIsAdjusting()) 
								return;
							ListSelectionModel lsm = (ListSelectionModel)e.getSource();
							if (lsm.isSelectionEmpty()) {
									//System.out.println("Tabela: no rows are selected...");
									String str = "Tabela: nenhuma linha selecionada...";
									JOptionPane.showMessageDialog(desk, str);
							} else {
									int selectedRow = lsm.getMinSelectionIndex();
									// System.out.println("Tabela: row selected: "+selectedRow);
							}
						}
					});

					TableColumn column = tabelaROI.getColumnModel().getColumn(0);;
					column.setPreferredWidth(50);
					column = tabelaROI.getColumnModel().getColumn(1);;
					column.setPreferredWidth(50);
							
					tablePanel.add(tabelaROI);
          JScrollPane tablesrollPane = new JScrollPane(tablePanel);
						
          tablesrollPane.setAutoscrolls(true);
					//---------------------------------
          m_zoomInButton = new JButton("Amplia");
          m_zoomInButton.addActionListener(this);
            
          m_zoomOutButton = new JButton("Reduz");
          m_zoomOutButton.addActionListener(this);
            
          m_originalButton = new JButton("Original");
          m_originalButton.addActionListener(this);
            
          m_zoomedInfo = new JLabel("Ampliada para 100%");
            
          topPanel.add(new JLabel("Ampliao  " + 
                                    (int)zoomPercentage + "%"));
          topPanel.add(m_zoomInButton);
          topPanel.add(m_originalButton);
          topPanel.add(m_zoomOutButton);
          topPanel.add(m_zoomedInfo);
                                    
          m_imagePanel = new ImagePanel(imagem, zoomPercentage);
          m_imagePanel.addMouseListener(this);
           
          m_imageContainer = new JPanel(new FlowLayout(FlowLayout.CENTER));
          m_imageContainer.setBackground(Color.BLACK);
          m_imageContainer.add(m_imagePanel);
            
          m_srollPane = new JScrollPane(m_imageContainer);						
          m_srollPane.setAutoscrolls(true);
       
          getContentPane().add(BorderLayout.NORTH, topPanel);
          getContentPane().add(BorderLayout.CENTER, m_srollPane);
					getContentPane().add(BorderLayout.EAST, tablesrollPane);
          getContentPane().add(BorderLayout.SOUTH, 
              new JLabel("Use boto da direita para opes", JLabel.CENTER));
          m_imagePanel.repaint();						
        }				
        setVisible(true);
    }
    
		// MTODOS PBLICOS
    /**
     * Action Listener method taking care of 
     * actions on the buttons
     */
    public void actionPerformed(ActionEvent ae) {
        if(ae.getSource().equals(m_zoomInButton)) {
            m_imagePanel.zoomIn();
            adjustLayout();
        } else if(ae.getSource().equals(m_zoomOutButton)) {
            m_imagePanel.zoomOut();
            adjustLayout();
        } else if(ae.getSource().equals(m_originalButton)) {
            m_imagePanel.originalSize();
            adjustLayout();
        }
    }
    
    /**
     * This method takes the Zoom Cursor Image
     * and creates the Zoom Custom Cursor which is 
     * shown on the Image Panel on mouse over
     * 
     * @param zoomcursorImage
     */
    public void setZoomCursorImage(Image zoomcursorImage) {
			m_zoomCursor = Toolkit.getDefaultToolkit().createCustomCursor(
                     zoomcursorImage, new Point(0, 0), "ZoomCursor");
    }
    
    /**
     * This method handles mouse clicks
     */
    public void mouseClicked(MouseEvent e) {
        
    }

    public void mouseEntered(MouseEvent e) {
        m_imageContainer.setCursor(m_zoomCursor);  		
    }
           
    public void mouseExited(MouseEvent e) {
        m_imageContainer.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));         
    }
           
    public void mousePressed(MouseEvent e) {
			if(e.getButton() == MouseEvent.BUTTON1){
				switch (tipoEvento)	{
					case 1:
						break;
					case 2:
						break;
					case 3:		// Criar ROI
						Point pt = new Point((int)(e.getX()/m_zoom), (int)(e.getY()/m_zoom));
						vetorROI.addElement(pt);		
						desenhaROI();
						break;
					case 4:		// Editar ROI
						break;
					case 5:		// Eliminar ROI
						break;
					case 6:		// Remover reas
						pt = new Point((int) (e.getX()/m_zoom), (int) (e.getY()/m_zoom));
						vetorROI.addElement(pt);		
						desenhaROI();
						break;
					}
						
      } else if (e.getButton() == MouseEvent.BUTTON3) {
				switch (tipoEvento)	{
					case 0:
						criaPopUpMenu(e);
						popup.show(e.getComponent(), e.getX(), e.getY());	
						popup = null;
						break;
					case 3:
						Point pt = new Point((int) (e.getX()/m_zoom), (int) (e.getY()/m_zoom));
						vetorROI.addElement(pt);
						desenhaROI();
						fechaROI();
						adicionaROI();
						tipoEvento = 0;
						imprimeTemas();
						break;
					case 4:
						tipoEvento = 0;
						break;
					case 6:
						break;								
				} // end switch
			}	// end else
		}	// end mousePressed
		
    public void mouseReleased(MouseEvent e) {
     
    }

    /**
     * This class is the Image Panel where the image
     * is drawn and scaled.
     * 
     * @author Rahul Sapkal(rahul@javareference.com)
     */
		public class ImagePanel extends JPanel {
        
			private double m_zoomPercentage;
      private Image m_image;
                
      /**
       * Constructor
       * 
       * @param image
       * @param zoomPercentage
       */                
      public ImagePanel(Image image, double zoomPercentage) {
				m_image = image;
        m_zoomPercentage = zoomPercentage / 100;
      }
        
      /**
       * This method is overriden to draw the image
       * and scale the graphics accordingly
       */
      public void paintComponent(Graphics grp) { 
				Graphics2D g2D = (Graphics2D)grp;
        int x, y;

				x = y = 0;

        // Set the background color to white
				//
        g2D.setColor(Color.WHITE);

        // Fill the rect
				//
        g2D.fillRect(0, 0, getWidth(), getHeight());					
				g2D.scale(m_zoom, m_zoom);						
				g2D.drawImage(m_image, 0, 0, this);
									
      }
       
      /**
       * This method is overriden to return the preferred size
       * which will be the width and height of the image plus
       * the zoomed width width and height. 
       * while zooming out the zoomed width and height is negative
       */
      public Dimension getPreferredSize() {
        return new Dimension((int)(m_image.getWidth(this) + 
                            (m_image.getWidth(this) * (m_zoom - 1))),
                            (int)(m_image.getHeight(this) + 
                            (m_image.getHeight(this) * (m_zoom -1 ))));
      }
        
      /**
       * Sets the new zoomed percentage
       * @param zoomPercentage
       */
      public void setZoomPercentage(int zoomPercentage) {
        m_zoomPercentage = ((double)zoomPercentage) / 100;    
      }
        
      /**
       * This method set the image to the original size
       * by setting the zoom factor to 1. i.e. 100%
       */
      public void originalSize() {
        m_zoom = 1;
				zoomFlag = true;
      }
        
      /**
       * This method increments the zoom factor with
       * the zoom percentage, to create the zoom in effect 
       */
      public void zoomIn() {
        m_zoom += m_zoomPercentage;
				zoomFlag = true;
      }            
        
      /**
       * This method decrements the zoom factor with the 
       * zoom percentage, to create the zoom out effect 
       */
      public void zoomOut() {
        m_zoom -= m_zoomPercentage;
            
        if(m_zoom < m_zoomPercentage) {
          if(m_zoomPercentage > 1.0) {
             m_zoom = 1.0;
          } else {
             zoomIn();
          }
        }
				zoomFlag = true;
     }
        
     /**
       * This method returns the currently
       * zoomed percentage
       * 
       * @return
       */
     public double getZoomedTo() {
       return m_zoom * 100; 
     }
		}	// end class ImagePanel

		public void ajustaViewPorte(Point pos){              
			JViewport viewport = (JViewport)m_srollPane.getViewport(); 
      viewport.setViewPosition(pos);   
    }

		// MTODOS PRIVADOS

    /**
     * This method adjusts the layout after zooming
     */
    private void adjustLayout() {
			m_imageContainer.doLayout();        
      m_srollPane.doLayout();
      m_zoomedInfo.setText("Ampliao " + (int)m_imagePanel.getZoomedTo() + "%");
    }
    
		private void criaPopUpMenu(final MouseEvent evt) {	
			JMenuItem menuItem; 
    
			popup = new JPopupMenu();
	    menuItem = new JMenuItem("Criar Tema");
			menuItem.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent event) {

					// Mtodo para adicionar tema no Vector vetorTemas
					//
					adicionaTema();
				}
			});
			popup.add(menuItem);

			menuItem = new JMenuItem("Criar ROI");
			menuItem.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent event) {
					if (vetorTemas.size() != 0){
						tipoEvento = 3;
					} else {
						String str = "Definir Tema!";
						JOptionPane.showMessageDialog(desk, str);
					}
				}
			});
			popup.add(menuItem);
	
			menuItem = new JMenuItem("Remover ROI");
			menuItem.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent event) {
					System.out.println("Remover ROI");
					int xc = (int) (evt.getX() / m_zoom);
					int yc = (int) (evt.getY() / m_zoom);
					removeROI(xc, yc);
				}
			});
			popup.add(menuItem);

			menuItem = new JMenuItem("Histograma");
			menuItem.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent event) {
					int xc = (int) (evt.getX() / m_zoom);
					int yc = (int) (evt.getY() / m_zoom);
					ROI roi = retornaROI( xc, yc);
					if (roi != null){
						histograma(roi);
					}
				}
			});
			popup.add(menuItem);

	    menuItem = new JMenuItem("Salvar arquivo");
			menuItem.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent event) {
					salvarArquivo();
				}
			});
			popup.add(menuItem);
		}

		private void adicionaTema() {
			int id;
			
			String sTema = JOptionPane.showInputDialog(null, "Entre nome do tema: ");
			int n = vetorTemas.size();
			if( n > 0 ) {
				Temas temaTmp = (Temas) vetorTemas.get(n-1);
				id = temaTmp.temaId + 1;
			} else {
				id = 1;
			}
			Temas temax = new Temas(sTema);
			temax.temaId = id;
			vetorTemas.addElement(temax);
			atualizaTabela(temax);
		}

		// Desenha histograma de uma ROI
		//
		private void histograma(ROI roiTmp) {
			int pixel, pixels[], n, xmin, xmax, ymin, ymax;
			float[] x1, y1;
			Vector vetorPixels, vetorCoord;
			Point pt;
			Rectangle2D rect;
	
			vetorPixels = new Vector();
			Raster raster = imagemOrig.getRaster();
			vetorCoord = roiTmp.roiCoordenadas;

			n = vetorCoord.size();
			x1 = new float[n];
			y1 = new float[n];			
			rect = roiTmp.rectROI;
			xmin = (int)rect.getMinX();
			xmax = (int)rect.getMaxX();
			ymin = (int)rect.getMinY();
			ymax = (int)rect.getMaxY();

			// Acessa general path
			//
			GeneralPath gp = roiTmp.gPath;
			
			// Acha os pixels que esto dentro da ROI.
			//
			for (int i = ymin; i < ymax; i++) {
				for (int j = xmin; j < xmax; j++) {
					if (gp.contains((double)j, (double)i)) {
						pixel = raster.getSample(j, i, 0);
						vetorPixels.addElement(new Integer(pixel));
					}
				}
			}
			pixels = new int[vetorPixels.size()];
			for (int i = 0; i < vetorPixels.size(); i++) {
				Integer integer = (Integer)vetorPixels.elementAt(i);
				pixel = integer.intValue();
				pixels[i] = pixel;
			}

			Histograma histo = new Histograma(pixels);
			histo.mostraHistograma(desk, "ROI");
		}

		private void salvarArquivo() {

			int doIt = JOptionPane.showConfirmDialog(null, "Confirma salvar arquivo?",
										"Salvar", JOptionPane.YES_NO_OPTION);
			if (doIt == 0) {	// Sim
				String sNome = JOptionPane.showInputDialog("Entre nome do arquivo: ");
				if (sNome != null) {
					sNome += ".dat";
					System.out.println("Salvar arquivo : " + sNome);
					try {
						FileWriter writer = new FileWriter(sNome);
						BufferedWriter buf_writer = new BufferedWriter(writer);
						String ln = "";

						int nt, na, nc, x1, y1, i;
						Temas temasTmp;
						ROI tmpROI;
						Vector roiCoord, amostrasTmp;	
						Point pt;

						// Identifica a quantidade de temas definidos pelo usurio
						//
						nt = vetorTemas.size();

						// Nmero de temas
						//
						ln += nt;
						grava_linha(ln, buf_writer);
						ln = "";

						// Percorre todos os temas armazenados
						//
						for (int ind = 0; ind < nt; ind++) {
							temasTmp = (Temas) vetorTemas.get(ind);	
							ln += temasTmp.tema + " : Id = " +	temasTmp.temaId;
							grava_linha(ln, buf_writer);
							ln = "";
							amostrasTmp = temasTmp.amostras;

							// Identifica a quantidade de amostras definida pelo usurio e
							// armazenada no Vector amostras
							//
							na = amostrasTmp.size();
							
							// Nmero de amostras
							//
							ln += na;
							grava_linha(ln, buf_writer);
							ln = "";
							
							// Percorre todas as amostras armazenadas
							//
							for (int indA = 0; indA < na; indA++){
								tmpROI = (ROI) amostrasTmp.get(indA);
								roiCoord = tmpROI.roiCoordenadas; 
								
								// Identifica a quantidade de coordenadas definida pelo usurio
								// e armazenada no Vector roiCoordenadas
								//
								nc = roiCoord.size();

								// Nmero de vrtices
								//
								ln += (nc - 1);
								grava_linha(ln, buf_writer);
								ln = "";
								i = 0;
								while (i < nc - 1){
									pt = (Point) roiCoord.get(i);
									ln += pt.x + " , " + pt.y;
									grava_linha(ln, buf_writer);
									ln = "";
									i++;
								}	
							}
						}											
						buf_writer.close();
					} catch (IOException e) {
						String str = "Erro na gravao do arquivo " + sNome;
						JOptionPane.showMessageDialog(desk, str);
					}
				} 
			}
		}

		private void grava_linha(String texto, BufferedWriter buf_writer) {
			try	{
				buf_writer.write(texto);
				buf_writer.newLine();		
			} catch (IOException e) {
				String str = "Erro na gravao da linha " + texto;
				JOptionPane.showMessageDialog(desk, str);
			} 
		}

		private void fechaROI() {
			int n, x1, y1;
			Point pt;
			GeneralPath path = new GeneralPath();
			Ellipse2D elipse;
			Graphics2D g2 = imagemTemp.createGraphics();
			Color cor;
		
			n = vetorTemas.size();
			Temas temaTmp = (Temas) vetorTemas.get(n-1);
			cor = temaTmp.temaCor;

			g2.setColor(cor);
			n = vetorROI.size();
			pt = (Point) vetorROI.get(0);	
			x1 = pt.x;
			y1 = pt.y;
			path.moveTo((float) x1,(float) y1);
			pt = (Point) vetorROI.get(n-1);	
			x1 = pt.x;
			y1 = pt.y;
			elipse = new Ellipse2D.Float(x1, y1, 1, 1);
			g2.fill(elipse);
			path.lineTo((float) x1,(float) y1);
			g2.setColor(cor);
			g2.draw(path);
			repaint();	
		}

		// Cria objeto ROI, atualiza e armazena em vetorTemas
		//
		private void adicionaROI(){	
			int somaX, somaY, i, n, xmin, xmax,	ymin, ymax;
			int largura, altura, lin, col, pixels = 0;
			int [][] maskImg;
			float[] x1 = null;
			float[] y1 = null;
			Point pt;
		
			n = vetorROI.size();
			x1 = new float[n];
			y1 = new float[n];
			ROI roiTmp = new ROI();	
			roiTmp.roiCoordenadas = vetorROI;
		
			somaX = 0;
			somaY = 0;
			pt = (Point)vetorROI.get(0);
			xmin = pt.x; xmax = pt.x;
			ymin = pt.y; ymax = pt.y;
			for (i = 0; i < n - 1; i++) {
				pt = (Point)vetorROI.get(i);
				x1[i] = pt.x;
				y1[i] = pt.y;
				somaX += pt.x;
				somaY += pt.y;
				xmin = (int)Math.min(xmin, x1[i]);
				ymin = (int)Math.min(ymin, y1[i]);
				xmax = (int)Math.max(xmax, x1[i]);
				ymax = (int)Math.max(ymax, y1[i]);
			}
			largura = (xmax - xmin) + 6;
			altura =  (ymax - ymin) + 6;
			roiTmp.rectROI = new Rectangle2D.Double(xmin, ymin, largura, altura);
			System.out.println("adicionaROI: x = "+xmin+" X = "+xmax+" y = "+ymin+" Y = "+ymax);

			maskImg = new int[largura][altura];
		
			// Cria general path
			// 1. Move para ponto inicial
			//
			GeneralPath gp = roiTmp.gPath;
			gp.moveTo(x1[0], y1[0]);

			// 2. Desenha os segmentos de reta
			//
			for (int j = 1; j < n; j++)
				gp.lineTo(x1[j], y1[j]);
			
			// 3. Fecha o polgono
			//
			gp.closePath();
		
			for (i = 0; i < altura; i++)
				for (int j = 0; j < largura; j++)
					maskImg[j][i] = 0;		
			lin = 3;
			for (i = ymin; i < ymax; i++) {
				col = 3;
				for (int j = xmin; j < xmax; j++) {
					if (gp.contains((double)j, (double)i)) {
						maskImg[col][lin] = 1;
						pixels++;
					}
					col++;					
				}
				lin++;
			}
			roiTmp.mascaraPixels = maskImg;
			n = vetorTemas.size();
			Temas temaTmp = (Temas) vetorTemas.get(n-1);
			System.out.println("Antes: pixels = " + temaTmp.numPixels);
			temaTmp.numPixels += pixels;
			atualizaTabela(temaTmp);
			System.out.println("Depois: pixels = " + temaTmp.numPixels);
			temaTmp.amostras.addElement(roiTmp);
			vetorROI = null;
			vetorROI = new Vector();	
		}

		private void removeROI(int xc, int yc){	
			System.out.println("Temos que programar!");
		}
 
		private void desenhaROI() {
			int n, x1, y1;
			Point pt;
			Ellipse2D elipse;
			GeneralPath path = new GeneralPath();		
			Graphics2D g2 = imagemTemp.createGraphics();
			Color cor;
		
			n = vetorTemas.size();
			Temas temaTmp = (Temas) vetorTemas.get(n-1);
			cor = temaTmp.temaCor;

			g2.setColor(cor);
			n = vetorROI.size();
			pt = (Point) vetorROI.get(0);	
			x1 = pt.x;
			y1 = pt.y;
			path.moveTo((float) x1,(float) y1);

			// i inicia com o valor "1" porque na primeira
			// posio temos o identificador e a quantidade de talhes
			//
			for (int i = 0; i < n ; i++){
				pt = (Point) vetorROI.get(i);	
				x1 = pt.x;
				y1 = pt.y;
				elipse = new Ellipse2D.Float(x1, y1, 1, 1);
				g2.fill(elipse);
				path.lineTo((float) x1,(float) y1);
			}
			g2.setColor(cor);
			g2.draw(path);
			repaint();
		}

	  // Mostra na tela de comando o contedo da estrutura tema e ROI
		//
		private void imprimeTemas() {
			int nt, na, nc, x1, y1, i, k, npt;
			Temas temasTmp;
			ROI tmpROI;
			Vector roiCoord, amostrasTmp;	
			Point pt;
			Color cor;

			nt = vetorTemas.size();
			npt = 6;
			for (int ind = 0; ind < nt; ind++) {
				temasTmp = (Temas) vetorTemas.get(ind);	
				cor = temasTmp.temaCor;
				amostrasTmp = temasTmp.amostras;
				na = amostrasTmp.size();
				for (int indA = 0;indA < na; indA++ ){
					tmpROI = (ROI) amostrasTmp.get(indA);
					roiCoord = tmpROI.roiCoordenadas;  
					nc = roiCoord.size();
					i = 0;
					k = 1;	
					while (i < nc){
						pt = (Point) roiCoord.get(i);
						k++;
						if (k == npt)	{
							System.out.println();
							k = 0;
						}
						i++;
					}	
				}
			}
		}

		// Mtodo para manusear a tabela de temas
		//
		private void atualizaTabela(Temas temaVec){
			int np = temaVec.numPixels;
			if (np == 0) {
				Object[] newRow = new Object[3];
				newRow[0] = temaVec.tema;
				newRow[1] = String.valueOf(temaVec.temaId);				
				newRow[2] = String.valueOf(0);			
				modeloTabela.addRow(newRow);
			} else {
				int val = retornaLinhaTabela(temaVec.tema);
				tabelaROI.setValueAt(new Integer(temaVec.numPixels), val, 2);
			}
		}

		private int retornaLinhaTabela(String nome){
		int n, val = -1;
		String txt;

		n = tabelaROI.getRowCount();
		for(int i = 0; i < n; i++){
      txt = (String) modeloTabela.getValueAt(i, 0);
			if (txt.equals(nome)){
				val = i;
				break;
			}
		}
		return val;
	}

	private ROI retornaROI(int xc, int yc){	
			System.out.println("retornaROI: inicio");
			int nt, na;
			GeneralPath gp;
			Temas temasTmp;
			ROI roiTmp = null;
	    nt = vetorTemas.size();
			for (int indT = 0; indT < nt; indT++) {
				temasTmp = (Temas) vetorTemas.get(indT);
				Vector amostrasTmp = temasTmp.amostras;
				na = amostrasTmp.size();
				for (int indA = 0;indA < na; indA++ ){
					roiTmp = (ROI) amostrasTmp.get(indA);
					gp = roiTmp.gPath;

					// Verifica se a coordenada xc, yc pertence a regio de 
					// interesse - ROI
					//
					if (gp.contains((double)xc, (double)yc))	{
						System.out.println("Achou ROI");
						return roiTmp;				
					}
					roiTmp = null;
				}
			}
			System.out.println("retornaROI: FIM");
			return roiTmp;
		}

}	