/******************************************************************************
SofiaImagens.java

Direitos Autorais Reservados (c) 2009 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob
os termos da Licena Pblica Geral GNU conforme publicada pela Free Software
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais 
detalhes.

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
Temple Street, Suite 330, Boston, MA 02111-1307 USA.

********************************************************************************

Parte integrante do software 'Sofia Imagens - SOFtware Inteligente de Anlise 
                                              de Imagens'.

Este fonte faz parte do livro:

	Processamento de Imagens Digitais: Mtodos Multivariados em Java.
	Jos Iguelmar Miranda.
	Embrapa Informtica Agropecuria.
	Campinas, maio de 2009.

Descrio:

 Esta classe cria a interface grfica do usurio e implementa todos os
 menus.
  
Entrada:

 Void

Sada:

 Void

Desenvolvido por:

    Jos Iguelmar Miranda

Informaes do CVS:
       $Source$:
       $Revision$:
       $Date$:

******************************************************************************/

package pID;

// Pacotes genricos
import java.io.File;
import java.io.IOException;
import java.util.Vector;
import java.text.DecimalFormat;

// Pacote Swing para interface grfica
import javax.swing.JDesktopPane;
import javax.swing.JOptionPane;
import javax.swing.JMenuItem;
import javax.swing.KeyStroke;
import javax.swing.JMenuBar;
import javax.swing.JFrame;
import javax.swing.JMenu;

// Pacotes do AWT
import java.awt.image.WritableRaster;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.Choice;

// Leitura em modo imediato - para J2SE 1.4+
import javax.imageio.ImageIO;

public class SofiaImagens extends JFrame implements ActionListener {

	// ATRIBUTOS

	// Cria objetos
	//
	Imagem img = null;
	EscolheImagem ei = null;
	VetorImagens vecImagens = new VetorImagens();
	Cluster cluster = null;
	JDesktopPane desktop;

	// CONSTRUTOR

  public SofiaImagens() {
		super("Sofia Imagens");

    int inset = 50;
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    setBounds(inset, inset, screenSize.width/2  - inset*2,
                  screenSize.height/2 - inset*2);

    // Constroi a GUI.
		//
    desktop = new JDesktopPane();
    setContentPane(desktop);
    setJMenuBar(createMenuBar());

		// Habilita movimento mais rpido da imagem
		//
    desktop.setDragMode(JDesktopPane.OUTLINE_DRAG_MODE);
	}

  protected JMenuBar createMenuBar() {
		JMenuBar menuBar = new JMenuBar();

    // Define menu para manipular arquivos
		//
    JMenu menuA = new JMenu("Arquivo");
    menuA.setMnemonic(KeyEvent.VK_A);
    menuBar.add(menuA);

    // Define primeiro item do menu
		//
    JMenuItem menuItem = new JMenuItem("Abrir");
    menuItem.setMnemonic(KeyEvent.VK_A);
    menuItem.setAccelerator(KeyStroke.getKeyStroke(
						 KeyEvent.VK_A, ActionEvent.ALT_MASK));
    menuItem.setActionCommand("abre");
    menuItem.addActionListener(this);
    menuA.add(menuItem);
    menuA.addSeparator();

    // Define segundo item do menu
		//
    menuItem = new JMenuItem("Sair");
    menuItem.setMnemonic(KeyEvent.VK_R);
    menuItem.setAccelerator(KeyStroke.getKeyStroke(
             KeyEvent.VK_R, ActionEvent.ALT_MASK));
    menuItem.setActionCommand("sair");
    menuItem.addActionListener(this);
    menuA.add(menuItem);

    // Define menu para manipular imagens
		//
    JMenu menuI = new JMenu("Imagem");
    menuI.setMnemonic(KeyEvent.VK_I);
    menuBar.add(menuI);

    // Define primeiro item do menu Imagem
		//
    JMenu menuH = new JMenu("Histograma");
    menuH.setMnemonic(KeyEvent.VK_H);
    menuI.add(menuH);

    // Define primeiro sub-item do menu Histograma
		//
    menuItem = new JMenuItem("Escolhe imagem");
    menuItem.setMnemonic(KeyEvent.VK_E);
    menuItem.setAccelerator(KeyStroke.getKeyStroke(
             KeyEvent.VK_E, ActionEvent.ALT_MASK));
    menuItem.setActionCommand("escolhe");
    menuItem.addActionListener(this);
    menuH.add(menuItem);

    // Define segundo sub-item do menu Histograma
		//
    menuItem = new JMenuItem("Mostra histograma");
    menuItem.setMnemonic(KeyEvent.VK_H);
    menuItem.setAccelerator(KeyStroke.getKeyStroke(
             KeyEvent.VK_H, ActionEvent.ALT_MASK));
    menuItem.setActionCommand("histo");
    menuItem.addActionListener(this);
    menuH.add(menuItem);

    // Define segundo item do menu Imagem
		//
    JMenu menuE = new JMenu("Estatstica");
    menuE.setMnemonic(KeyEvent.VK_E);
    menuI.add(menuE);

    // Define primeiro sub-item do menu Estatstica
		//
    JMenu menuU = new JMenu("Univariada");
    menuU.setMnemonic(KeyEvent.VK_U);
    menuE.add(menuU);

    // Define primeiro sub-item do menu Univariada
		//
		menuItem = new JMenuItem("Escolhe imagem");
    menuItem.setMnemonic(KeyEvent.VK_E);
    menuItem.setAccelerator(KeyStroke.getKeyStroke(
             KeyEvent.VK_E, ActionEvent.ALT_MASK));
    menuItem.setActionCommand("escolheU");
    menuItem.addActionListener(this);
    menuU.add(menuItem);

    // Define segundo sub-item do menu Univariada
		//
    menuItem = new JMenuItem("Mostra estatstica");
    menuItem.setMnemonic(KeyEvent.VK_M);
    menuItem.setAccelerator(KeyStroke.getKeyStroke(
             KeyEvent.VK_M, ActionEvent.ALT_MASK));
    menuItem.setActionCommand("univar");
    menuItem.addActionListener(this);
    menuU.add(menuItem);

    // Define segundo sub-item do menu Estatstica
		//
    JMenu menuM = new JMenu("Multivariada");
    menuU.setMnemonic(KeyEvent.VK_U);
    menuE.add(menuM);

    // Define primeiro sub-item do menu Multivariada
		//
		menuItem = new JMenuItem("Escolhe imagens");
    menuItem.setMnemonic(KeyEvent.VK_E);
    menuItem.setAccelerator(KeyStroke.getKeyStroke(
             KeyEvent.VK_E, ActionEvent.ALT_MASK));
    menuItem.setActionCommand("escolheM");
    menuItem.addActionListener(this);
    menuM.add(menuItem);

    // Define segundo sub-item do menu Multivariada
		//
		menuItem = new JMenuItem("Mostra estatsticas");
    menuItem.setMnemonic(KeyEvent.VK_M);
    menuItem.setAccelerator(KeyStroke.getKeyStroke(
             KeyEvent.VK_M, ActionEvent.ALT_MASK));
    menuItem.setActionCommand("multi");
    menuItem.addActionListener(this);
    menuM.add(menuItem);

    // Define terceiro item do menu Imagem
		//
    JMenu menuF = new JMenu("Falsar cor");
    menuF.setMnemonic(KeyEvent.VK_F);
    menuI.add(menuF);

    // Define primeiro sub-item do menu Falsar cor
		//
		menuItem = new JMenuItem("Escolhe imagens");
    menuItem.setMnemonic(KeyEvent.VK_E);
    menuItem.setAccelerator(KeyStroke.getKeyStroke(
             KeyEvent.VK_E, ActionEvent.ALT_MASK));
    menuItem.setActionCommand("escolheFC");
    menuItem.addActionListener(this);
    menuF.add(menuItem);

    // Define menu para processamento de imagens
		//
    JMenu menuP = new JMenu("Processa");
    menuP.setMnemonic(KeyEvent.VK_P);
    menuBar.add(menuP);

    // Define primeiro item do menu Processa
		//
    JMenu menuCP = new JMenu("Componente Principal");
    menuCP.setMnemonic(KeyEvent.VK_C);
    menuP.add(menuCP);

    // Define primeiro sub-item do menu Componente Principal
		//
    menuItem = new JMenuItem("Escolhe imagem");
    menuItem.setMnemonic(KeyEvent.VK_E);
    menuItem.setAccelerator(KeyStroke.getKeyStroke(
             KeyEvent.VK_E, ActionEvent.ALT_MASK));
    menuItem.setActionCommand("escolheCP");
    menuItem.addActionListener(this);
    menuCP.add(menuItem);

    // Define segundo sub-item do menu Componente Principal
		//
    menuItem = new JMenuItem("Calcula CP");
    menuItem.setMnemonic(KeyEvent.VK_C);
    menuItem.setAccelerator(KeyStroke.getKeyStroke(
             KeyEvent.VK_C, ActionEvent.ALT_MASK));
    menuItem.setActionCommand("calculaCP");
    menuItem.addActionListener(this);
    menuCP.add(menuItem);

    // Define segundo item do menu Processa
		//
    JMenu menuCO = new JMenu("Regresso");
    menuCO.setMnemonic(KeyEvent.VK_R);
    menuP.add(menuCO);

    // Define primeiro sub-item do menu Correlao
		//
    menuItem = new JMenuItem("Escolhe imagem");
    menuItem.setMnemonic(KeyEvent.VK_E);
    menuItem.setAccelerator(KeyStroke.getKeyStroke(
             KeyEvent.VK_E, ActionEvent.ALT_MASK));
    menuItem.setActionCommand("escolheCO");
    menuItem.addActionListener(this);
    menuCO.add(menuItem);

    // Define segundo sub-item do menu Correlao
		//
    menuItem = new JMenuItem("Regresso simples");
    menuItem.setMnemonic(KeyEvent.VK_M);
    menuItem.setAccelerator(KeyStroke.getKeyStroke(
             KeyEvent.VK_M, ActionEvent.ALT_MASK));
    menuItem.setActionCommand("regSimples");
    menuItem.addActionListener(this);
    menuCO.add(menuItem);

    // Define terceiro sub-item do menu Correlao
		//
    menuItem = new JMenuItem("Regresso mltipla");
    menuItem.setMnemonic(KeyEvent.VK_M);
    menuItem.setAccelerator(KeyStroke.getKeyStroke(
             KeyEvent.VK_M, ActionEvent.ALT_MASK));
    menuItem.setActionCommand("regMultipla");
    menuItem.addActionListener(this);
    menuCO.add(menuItem);

    // Define menu para classificao de imagens
		//
    JMenu menuC = new JMenu("Classificao");
    menuC.setMnemonic(KeyEvent.VK_C);
    menuBar.add(menuC);

    // Define primeiro item do menu Classifica
		//
    JMenu menuNS = new JMenu("No-supervisionada");
    menuNS.setMnemonic(KeyEvent.VK_N);
    menuC.add(menuNS);

    // Define primeiro sub-item do menu no-supervisionada
		//
    menuItem = new JMenuItem("Escolhe imagem");
    menuItem.setMnemonic(KeyEvent.VK_E);
    menuItem.setAccelerator(KeyStroke.getKeyStroke(
             KeyEvent.VK_E, ActionEvent.ALT_MASK));
    menuItem.setActionCommand("escolheNS");
    menuItem.addActionListener(this);
    menuNS.add(menuItem);

    // Define terceiro sub-item do menu no-supervisionada
		//
    JMenu menuHeu = new JMenu("Heurstico");
    menuHeu.setMnemonic(KeyEvent.VK_H);
    menuNS.add(menuHeu);

    // Define primeiro sub-item do menu Histograma
		//
    menuItem = new JMenuItem("Leader");
    menuItem.setMnemonic(KeyEvent.VK_L);
    menuItem.setAccelerator(KeyStroke.getKeyStroke(
             KeyEvent.VK_L, ActionEvent.ALT_MASK));
    menuItem.setActionCommand("leader");
    menuItem.addActionListener(this);
    menuHeu.add(menuItem);

    // Define segundo sub-item do menu Histograma
		//
    menuItem = new JMenuItem("Joiner");
    menuItem.setMnemonic(KeyEvent.VK_J);
    menuItem.setAccelerator(KeyStroke.getKeyStroke(
             KeyEvent.VK_J, ActionEvent.ALT_MASK));
    menuItem.setActionCommand("joiner");
    menuItem.addActionListener(this);
    menuHeu.add(menuItem);

    
    // Define quarto sub-item do menu no-supervisionada
		//
    menuItem = new JMenuItem("K-mdias");
    menuItem.setMnemonic(KeyEvent.VK_K);
    menuItem.setAccelerator(KeyStroke.getKeyStroke(
             KeyEvent.VK_K, ActionEvent.ALT_MASK));
    menuItem.setActionCommand("kmedia");
    menuItem.addActionListener(this);
    menuNS.add(menuItem);

    // Define quinto sub-item do menu no-supervisionada
		//
    menuItem = new JMenuItem("Fuzzy c-mdias");
    menuItem.setMnemonic(KeyEvent.VK_F);
    menuItem.setAccelerator(KeyStroke.getKeyStroke(
             KeyEvent.VK_F, ActionEvent.ALT_MASK));
    menuItem.setActionCommand("fcmedia");
    menuItem.addActionListener(this);
    menuNS.add(menuItem);

    // Define segundo item do menu Classifica
		//
    JMenu menuSu = new JMenu("Supervisionada");
    menuSu.setMnemonic(KeyEvent.VK_S);
    menuC.add(menuSu);

    // Define primeiro sub-item do menu supervisionada
		//
    menuItem = new JMenuItem("Treinamento");
    menuItem.setMnemonic(KeyEvent.VK_E);
    menuItem.setAccelerator(KeyStroke.getKeyStroke(
             KeyEvent.VK_E, ActionEvent.ALT_MASK));
    menuItem.setActionCommand("escolheS");
    menuItem.addActionListener(this);
    menuSu.add(menuItem);

    // Define segundo sub-item do menu supervisionada
		//
    menuItem = new JMenuItem("Assinatura espectral");
    menuItem.setMnemonic(KeyEvent.VK_E);
    menuItem.setAccelerator(KeyStroke.getKeyStroke(
             KeyEvent.VK_E, ActionEvent.ALT_MASK));
    menuItem.setActionCommand("assinatura");
    menuItem.addActionListener(this);
    menuSu.add(menuItem);

    // Define terceiro sub-item do menu supervisionada
		//
    menuItem = new JMenuItem("Vizinho mais prximo");
    menuItem.setMnemonic(KeyEvent.VK_V);
    menuItem.setAccelerator(KeyStroke.getKeyStroke(
             KeyEvent.VK_V, ActionEvent.ALT_MASK));
    menuItem.setActionCommand("vizinho");
    menuItem.addActionListener(this);
    menuSu.add(menuItem);

    // Define quarto sub-item do menu supervisionada
		//
    menuItem = new JMenuItem("Vizinho (Z Score)");
    menuItem.setMnemonic(KeyEvent.VK_V);
    menuItem.setAccelerator(KeyStroke.getKeyStroke(
             KeyEvent.VK_V, ActionEvent.ALT_MASK));
    menuItem.setActionCommand("zScore");
    menuItem.addActionListener(this);
    menuSu.add(menuItem);

    // Define quinto sub-item do menu supervisionada
		//
    menuItem = new JMenuItem("Paralelepipedo");
    menuItem.setMnemonic(KeyEvent.VK_P);
    menuItem.setAccelerator(KeyStroke.getKeyStroke(
             KeyEvent.VK_P, ActionEvent.ALT_MASK));
    menuItem.setActionCommand("paralel");
    menuItem.addActionListener(this);
    menuSu.add(menuItem);

    // Define sexto sub-item do menu supervisionada
		//
    menuItem = new JMenuItem("MaxVer");
    menuItem.setMnemonic(KeyEvent.VK_M);
    menuItem.setAccelerator(KeyStroke.getKeyStroke(
             KeyEvent.VK_M, ActionEvent.ALT_MASK));
    menuItem.setActionCommand("maxver");
    menuItem.addActionListener(this);
    menuSu.add(menuItem);

    // Define stimo sub-item do menu supervisionada
    menuItem = new JMenuItem("Rede de neurnios");
    menuItem.setMnemonic(KeyEvent.VK_N);
    menuItem.setAccelerator(KeyStroke.getKeyStroke(
             KeyEvent.VK_N, ActionEvent.ALT_MASK));
    menuItem.setActionCommand("neuronio");
    menuItem.addActionListener(this);
    menuSu.add(menuItem);

    return menuBar;
  }

  // Responde  seleo no menu
	//
  public void actionPerformed(ActionEvent e) {

		String[] strImagens;

		if ("abre".equals(e.getActionCommand())) { // Abre imagem
			img = new Imagem();
			if (img.retornaBandas() > 1) {
				String msg = "nmero de bandas imagem > 1. Usando um canal.";
				String titulo = "Abre imagem";
				JOptionPane.showMessageDialog(desktop, msg, titulo, 0);
			}
			if (img.retornaNomeArquivoImagem() != null) 
				vecImagens.adicionaElemento((Imagem)img);
			if (img.biImagem != null) {
				img.mostraImagem(desktop);
			} else {
				String msg = "Abre: Abrir arquivo imagem!";
				String titulo = "Abre imagem";
				JOptionPane.showMessageDialog(desktop, msg, titulo, 0);
			}
		} else	// Histo
      if ("escolhe".equals(e.getActionCommand())) {
				if (img != null) {

					// L nome das imagens para escolha
					//
					strImagens = new String[vecImagens.comprimento()];
					Imagem imagem = null;
					for (int i = 0; i < vecImagens.comprimento(); i++)	{
						imagem = (Imagem)vecImagens.elementoEm(i);
						strImagens[i] = imagem.retornaNomeArquivoImagem();
					}

					// O objeto 'EscolheImagem' tem dois construtores, um para estatstica
					// univariada: 
					//	- public EscolheImagem(String[] strImagens, int single).
					// E outro para estatstica multivariada:
					//	- public EscolheImagem(String[] strImagens).
					// No caso do histograma, chamamos o construtor univariado.
					//
					ei = new EscolheImagem(strImagens, 1);
				}	else {
					String msg = "Histo: Abrir arquivo imagem!";
					String titulo = "Histograma";
					JOptionPane.showMessageDialog(desktop, msg, titulo, 0);
				}
			} else
			if ("histo".equals(e.getActionCommand())) {
				int i = 0;

				// Mostra histograma da imagem escolhida
				//
				if (ei != null) {
					Imagem imagem = null;
					do {
						imagem = (Imagem)vecImagens.elementoEm(i);
						i++;
					}	while (!(ei.imagemEscolhida.equals(imagem.retornaNomeArquivoImagem())));
					Histograma histo = new Histograma(imagem.retornaVetorPixels());
					histo.mostraHistograma(desktop, ei.imagemEscolhida);
					System.out.println("w,h = "+ imagem.retornaLargura()+","+imagem.retornaAltura());
				}	else {
					String msg = "Histo: escolher imagem!";
					String titulo = "Histograma";
					JOptionPane.showMessageDialog(desktop, msg, titulo, 0);
				}
		} else  // Estatstica univariada
      if ("escolheU".equals(e.getActionCommand())) {
				if (img != null) {

					// L nome das imagens para escolha
					//
					strImagens = new String[vecImagens.comprimento()];
					Imagem imagem = null;
					for (int i = 0; i < vecImagens.comprimento(); i++)	{
						imagem = (Imagem)vecImagens.elementoEm(i);
						strImagens[i] = imagem.retornaNomeArquivoImagem();
					}
					ei = new EscolheImagem(strImagens, 1);
				}	else {
					String msg = "Univar: Abrir arquivo imagem!";
					String titulo = "Estatstica univariada";
					JOptionPane.showMessageDialog(desktop, msg, titulo, 0);
				}
			} else
				if ("univar".equals(e.getActionCommand())) {
					int i = 0;

					// Mostra estatstica da imagem escolhida
					//
					if (ei != null) {
						Imagem imagem = null;
						do {
							imagem = (Imagem)vecImagens.elementoEm(i);
							i++;
						}	while (!(ei.imagemEscolhida.equals(imagem.retornaNomeArquivoImagem())));
						Univariada univ = new Univariada(imagem.retornaVetorPixels());
						univ.mostraResultados(desktop, imagem.retornaNomeArquivoImagem());
					}	else {
						String msg = "Univar: escolher imagem!";
						String titulo = "Estatstica univariada";
						JOptionPane.showMessageDialog(desktop, msg, titulo, 0);
					}
		} else // Estatstica multivariada - escolhe imagens
			if ("escolheM".equals(e.getActionCommand())) {
				if (img != null) {

					// L nome das imagens para escolha
					//
					strImagens = new String[vecImagens.comprimento()];
					Imagem imagem = null;
					for (int i = 0; i < vecImagens.comprimento(); i++)	{
						imagem = (Imagem)vecImagens.elementoEm(i);
						strImagens[i] = imagem.retornaNomeArquivoImagem();
					}

					// Aqui chamamos o construtor para estatstica multivariada do objeto
					// EscolheImagem.
					//
					ei = new EscolheImagem(strImagens);
				}	else {
					String msg = "Multivar: Abrir arquivo imagem!";
					String titulo = "Estatstica multivariada";
					JOptionPane.showMessageDialog(desktop, msg, titulo, 0);
				}
			} else	// Estatstica multivariada - clculos
				if ("multi".equals(e.getActionCommand())) {
					if (ei != null) {
						int numBandas = ei.imagensEscolhidas.length;
						int[] larguras = new int[numBandas];
						int[] alturas = new int[numBandas];
						Imagem imagem = null;

						Vector src = new Vector();
						for (int i = 0; i < numBandas; i++)	{
							imagem = 
								(Imagem)vecImagens.elementoEm(ei.indiceImagensEscolhidas[i]);
							src.addElement((int[])imagem.retornaVetorPixels());
							larguras[i] = imagem.retornaLargura();
							alturas[i] = imagem.retornaAltura();
						}

						// Primeiro, testa se imagens tm a mesma dimenso
						//
						for (int k = 0; k < numBandas - 1; k++) {
							if (larguras[k] != larguras[k+1]) {
								String msg = "Imagens com largura (#colunas) diferentes";
								String titulo = "Estatstica multivariada";
								JOptionPane.showMessageDialog(desktop, msg, titulo, 0);
							}
							if (alturas[k] != alturas[k+1]) {
								String msg = "Imagens com altura (#linhas) diferentes";
								String titulo = "Estatistica multivariada";
								JOptionPane.showMessageDialog(desktop, msg, titulo, 0);
							}
						}

						// Se tudo OK, ento calcula estatsticas multivariadas
						//
						Multivariada multiv = new Multivariada(src);
						multiv.mostraResultados(desktop);
					}	else {
						String msg = "Multivar: Abrir arquivo imagem!";
						String titulo = "Estatstica multivariada";
						JOptionPane.showMessageDialog(desktop, msg, titulo, 0);
					}		
		} else 	// Composio em falsa cor: escolhe imagens
			if ("escolheFC".equals(e.getActionCommand())) {
				if (img != null) {

					// L nome das imagens para escolha
					//
					strImagens = new String[vecImagens.comprimento()];
					String[] strPath = new String[vecImagens.comprimento()];
					Imagem imagem = null;
					for (int i = 0; i < vecImagens.comprimento(); i++)	{
						imagem = (Imagem)vecImagens.elementoEm(i);
						strPath[i] = imagem.retornaPathArquivoImagem();
						strImagens[i] = imagem.retornaNomeArquivoImagem();
					}

					// Escolhe bandas para composio
					//
					new EscolheBandas(strPath, strImagens);
				}	else {
					String msg = "Abrir arquivo imagem!";
					String titulo = "Falsa cor";
					JOptionPane.showMessageDialog(desktop, msg, titulo, 0);
				}
		} else // Componente principal (CP) - escolhe imagens
				if ("escolheCP".equals(e.getActionCommand())) {
					if (img != null) {

						// 1. L nome das imagens para escolha
						//
						strImagens = new String[vecImagens.comprimento()];
						Imagem imagem = null;
						for (int i = 0; i < vecImagens.comprimento(); i++)	{
							imagem = (Imagem)vecImagens.elementoEm(i);
							strImagens[i] = imagem.retornaNomeArquivoImagem();
						}

						// 2. Escolhe as imagens
						//
						ei = new EscolheImagem(strImagens);
					}	else {
						String msg = "Abrir arquivo imagem!";
						String titulo = "Componente Principal";
						JOptionPane.showMessageDialog(desktop, msg, titulo, 0);
					}
				} else	// Componente Principal - clculos
					if ("calculaCP".equals(e.getActionCommand())) {
						if (ei != null) {					
							Imagem imagem = null;
							Vector src = new Vector();
							for (int i = 0; i < ei.imagensEscolhidas.length; i++)	{
								imagem = (Imagem)vecImagens.elementoEm(ei.indiceImagensEscolhidas[i]);
								src.addElement((int[])imagem.retornaVetorPixels());
							}

							// A altura e a largura da imagem original so necessrios para 
							// definir a dimenso das imagens para as componentes principais.
							//
							int w = imagem.retornaLargura();
							int	h = imagem.retornaAltura();
							CPrincipal cp = new CPrincipal(src, w, h);
							cp.mostraComponente(desktop, w, h);
						}	else {
							String msg = "Abrir arquivo imagem!";
							String titulo = "Componente Principal";
							JOptionPane.showMessageDialog(desktop, msg, titulo, 0);
						}				
		} else // Regresso simples - escolhe imagens
				if ("escolheCO".equals(e.getActionCommand())) {
					if (img != null) {

						// L nome das imagens para escolha
						//
						strImagens = new String[vecImagens.comprimento()];
						Imagem imagem = null;
						for (int i = 0; i < vecImagens.comprimento(); i++)	{
							imagem = (Imagem)vecImagens.elementoEm(i);
							strImagens[i] = imagem.retornaNomeArquivoImagem();
						}
						ei = new EscolheImagem(strImagens);
					}	else {
						String msg = "Abrir arquivo imagem!";
						String titulo = "Regresso Linear";
						JOptionPane.showMessageDialog(desktop, msg, titulo, 0);
					}
				} else	// Regresso simples
						if ("regSimples".equals(e.getActionCommand())) {
							if (ei != null)	{
								int w, h;
								Imagem imagem = null;
								strImagens = new String[vecImagens.comprimento()];
								Vector src = new Vector();
								for (int i = 0; i < ei.imagensEscolhidas.length; i++)	{
									imagem = 
										(Imagem)vecImagens.elementoEm(ei.indiceImagensEscolhidas[i]);
									src.addElement((int[])imagem.retornaVetorPixels());
									strImagens[i] = imagem.retornaNomeArquivoImagem();
								}
								w = imagem.retornaLargura();
								h = imagem.retornaAltura();
								Regress correl = new Regress(src);
								correl.mostraGrafico(desktop, strImagens[0], strImagens[1], w, h);
							}	else {
								String msg = "Abrir arquivo imagem!";
								String titulo = "Regresso Linear";
								JOptionPane.showMessageDialog(desktop, msg, titulo, 0);
							}
						} else 	// Regresso mltipla
							if ("regMultipla".equals(e.getActionCommand())) {
								int nB;
								if (img != null) {

									// L nome das imagens para escolha
									//
									nB = vecImagens.comprimento();
									if (nB < 3)	{
										String msg = "Mnimo de 3 imagens!";
										String titulo = "Regresso Mltipla";
										JOptionPane.showMessageDialog(desktop, msg, titulo, 0);
									} else {
										strImagens = new String[nB];
										String[] strPath = new String[nB];
										Imagem imagem = null;
										for (int i = 0; i < nB; i++)	{
											imagem = (Imagem)vecImagens.elementoEm(i);
											strPath[i] = imagem.retornaPathArquivoImagem();
											strImagens[i] = imagem.retornaNomeArquivoImagem();
										}
										new BandasRegMulti(strPath, strImagens);
									}
							}	else {
								String msg = "Abrir arquivo imagem!";
								String titulo = "Regresso Mltipla";
								JOptionPane.showMessageDialog(desktop, msg, titulo, 0);
							}
		} else	// Classificao no supervisionada: primeiro, escolhe imagens
				if ("escolheNS".equals(e.getActionCommand())) {
					if (img != null) {

						// 1. L nome das imagens para escolha
						//
						strImagens = new String[vecImagens.comprimento()];
						Imagem imagem = null;
						for (int i = 0; i < vecImagens.comprimento(); i++)	{
							imagem = (Imagem)vecImagens.elementoEm(i);
							strImagens[i] = imagem.retornaNomeArquivoImagem();
						}

						// 2. Escolhe as imagens
						//
						ei = new EscolheImagem(strImagens);
					}	else {
						String msg = "Classificao: Abrir arquivo imagem!";
						String titulo = "Classifica imagens";
						JOptionPane.showMessageDialog(desktop, msg, titulo, 0);
					}
				} else	// Classificao no supervisionada: heurstico (leader)
						if ("leader".equals(e.getActionCommand())) {

							// 3. Chama algoritmo para definir grupos
							//
							if (ei != null) {
								cluster = new Cluster();
								cluster.paramHeuristico(desktop);
								leader();
							}	else {
								String msg = "Heurstico: Abrir arquivo imagem!";
								String titulo = "Mtodo Heurstico";
								JOptionPane.showMessageDialog(desktop, msg, titulo, 0);
							}		
				} else	// Classificao no supervisionada: heurstico (joiner)
					if ("joiner".equals(e.getActionCommand())) {
						String str = "Heurstico (joiner): implementar!";
						JOptionPane.showMessageDialog(desktop, str);
				} else	// Classificao: K-mdias
					if ("kmedia".equals(e.getActionCommand())) {
						if (ei != null) {
							cluster = new Cluster();
							cluster.paramKMedias(desktop);
							calculaKmedias();
						}	else {
							String msg = "K-mdias: Abrir arquivo imagem!";
							String titulo = "K-mdias";
							JOptionPane.showMessageDialog(desktop, msg, titulo, 0);
						}	
				} else	// Classificao no supervisionada: fuzzy c-mdias
					if ("fcmedia".equals(e.getActionCommand())) {
						if (ei != null) {
							cluster = new Cluster();
							cluster.paramFCM(desktop);
							System.out.println("Grupos: " + cluster.retornaGrupos() +
													"\nmax. iteracoes: " + cluster.retornaMaximoIteracoes() +
													"\nepsilon: " + cluster.retornaEpsilon() +
													"\nfuzziness: " + cluster.retornaFuzziness());
							calculaFuzzyCMedias();
						}	else {
							String msg = "Fuzzy c-mdias: Abrir arquivo imagem!";
							String titulo = "Fuzzy c-mdias";
							JOptionPane.showMessageDialog(desktop, msg, titulo, 0);
						}	
				}
		 else	// Classificao supervisionada
			if ("escolheS".equals(e.getActionCommand())) {
				if (img != null) {				
					ImagemROI imgROI = new ImagemROI(img.biImagem, 100, 
															 img.retornaNomeArquivoImagem(), desktop);
					desktop.add(imgROI);
				}	else {
					String msg = "Supervisionada: Abrir arquivo imagem!";
					String titulo = "Classificao Supervisionada";
					JOptionPane.showMessageDialog(desktop, msg, titulo, 0);
				}
			} else	//

				// Este mtodo l um arquivo (.dat) com os temas e os vrtices dos
				// polgonos que definem as amostras (ROIs) de cada tema.
				// Em seguida, calcula as estatsticas de cada tema, ou as
				// assinaturas espectrais, e as armazena no arquivo com
				// extenso .sig.
				// O arquivo .sig gerado ser usado posteriormente pelos
				// mtodos de classificao supervisionada: vizinho mais
				// prximo, vizinho mais prximo com Zscore, paraleleppedo
				// e mxima verossimilhana (maxver).
				//
				if ("assinatura".equals(e.getActionCommand())) {
					File arquivoDAT = null;
					AssinaturaEspectral assinatura = null;
					assinatura = new AssinaturaEspectral(desktop);
					arquivoDAT = assinatura.abreArquivoAmostras();
					if (arquivoDAT != null) {
						assinatura.abreArquivoImagens();
						assinatura.calculaAssinatura(arquivoDAT);
					} else {
						String msg = "Abrir arquivo de amostras (.dat)!";
						String titulo = "Assinatura Espectral";
						JOptionPane.showMessageDialog(desktop, msg, titulo, 0);
					}
				} else	// Classificao: vizinho mais prximo
						if ("vizinho".equals(e.getActionCommand())) {
							File arquivoSIG = null;
							DistanciaMinima minDist = new DistanciaMinima();
							arquivoSIG = minDist.abreArquivoAssinaturas(desktop);
							if (arquivoSIG != null) {
								minDist.abreBandas(arquivoSIG);
								minDist.classificaImagem(arquivoSIG);
							} else {
								String msg = "Abrir arquivo de assinatura espectral!";
								String titulo = "Vizinho mais prximo da mdia";
								JOptionPane.showMessageDialog(desktop, msg, titulo, 0);
							}
				} else	// Classificao: vizinho mais prximo com Zscore
						if ("zScore".equals(e.getActionCommand())) {
							File arquivoSIG = null;
							DMZScore minDistZ = new DMZScore();
							arquivoSIG = minDistZ.abreArquivoAssinaturas(desktop);
							if (arquivoSIG != null) {
								minDistZ.abreBandas(arquivoSIG);
								minDistZ.classificaImagem(arquivoSIG);
							} else {
								String msg = "Z-score: Abrir arquivo de assinatura espectral!";
								String titulo = "Vizinho com distncia normalizada";
								JOptionPane.showMessageDialog(desktop, msg, titulo, 0);
							}           
				} else	// Classificao: paraleleppedo
						if ("paralel".equals(e.getActionCommand())) {
							File arquivoSIG = null;
							Paralelepipedo piped = new Paralelepipedo();
							arquivoSIG = piped.abreArquivoAssinaturas(desktop);
							if (arquivoSIG != null) {
								piped.abreBandas(arquivoSIG);
								piped.classificaImagem(arquivoSIG);
							} else {
								String msg = "Abrir arquivo de assinatura espectral!";
								String titulo = "Mtodo Paraleleppedo";
								JOptionPane.showMessageDialog(desktop, msg, titulo, 0);
							}
				} else	// Classificao: maxver
						if ("maxver".equals(e.getActionCommand())) {
							File arquivoSIG = null;
							MaxVer max = new MaxVer();
							arquivoSIG = max.abreArquivoAssinaturas(desktop);
							if (arquivoSIG != null) {
								max.abreBandas(arquivoSIG);
								max.classificaImagem(arquivoSIG);
							} else {
								String msg = "Abrir arquivo de assinatura espectral!";
								String titulo = "Mtodo da mxima verossimilhana";
								JOptionPane.showMessageDialog(desktop, msg, titulo, 0);
							}
				} else	// Classificao: rede de neurnios
					if ("neuronio".equals(e.getActionCommand())) {

						// Cria objeto RNA - Rede de Neurnios Artificiais
						//
						RNA rna = new RNA();

						// Certifica que arquivo de treinamento foi aberto
						//
						if ((rna.retornaArquivoTreinamento() == null) ||
								(rna.retornaArquivoHeader() == null)) {
							String msg = "Abrir arquivos de treinamento e cabealho!";
							String titulo = "Rede de Neurnios Artificiais";
							JOptionPane.showMessageDialog(desktop, msg, titulo, 0);
						} else {
						
							// Define variveis de inicializao da rede.
							//
							int nEpochs = 15000;
							int nPeek = 100;
							float threshold = 0.002f;
							float range = 0.01f;		// valor mximo para criar pesos aleatrios
							long seed = 24541;			// valor usado na funo aleatria
							float lv = 0.003f;			// taxa de aprendizado (learning veloc.)
							float momento = 0.0025f;
																		
							int camadas = 3;
							int entradas = 3;
							int saida = 1;
							int ocultos = 10;
							int outFunc = 0;			// AsymmetricSigmoidFunction
							int hiddenFunc = 0; 	// AsymmetricSigmoidFunction

							// Cria topologia da rede
							//
							if (rna.criaTopologia(camadas, entradas, saida, ocultos, outFunc,
																			 hiddenFunc, seed, range)) {
								String msg = "Criou topologia da rede!";
								String titulo = "Rede de Neurnios Artificiais";
								JOptionPane.showMessageDialog(desktop, msg, titulo, 1);
							}
							else {
								String msg = "No criou topologia da rede!";
								String titulo = "Rede de Neurnios Artificiais";
								JOptionPane.showMessageDialog(desktop, msg, titulo, 0);
							}
								
							// Gera o arquivo de exemplos com o arquivo de treinamento
							//
							if (rna.geraExemplos()) {
								String msg = "Gerou base de exemplos!";
								String titulo = "Rede de Neurnios Artificiais";
								JOptionPane.showMessageDialog(desktop, msg, titulo, 1);
							}
							else {
								String msg = "No criou base de exemplos!";
								String titulo = "Rede de Neurnios Artificiais";
								JOptionPane.showMessageDialog(desktop, msg, titulo, 0);
							}
							
							// Treina a rede
							//
							
							if (rna.treinaRede(threshold, lv, momento, nEpochs, nPeek)) {
								String msg = "A rede foi treinada!";
								String titulo = "Rede de Neurnios Artificiais";
								JOptionPane.showMessageDialog(desktop, msg, titulo, 1);
							}
							else {
								String msg = "Problema treinando a rede!";
								String titulo = "Rede de Neurnios Artificiais";
								JOptionPane.showMessageDialog(desktop, msg, titulo, 0);
							}
						
							// Ativa a rede. Este procedimento configura os valores
							// de entrada da rede, ativa a rede e obtm seus valores de 
							// sada
							//
							if (rna.abreBandas())
								rna.classificaImagem();
							else {
								String msg = "Problema com arquivos de imagens!";
								String titulo = "Rede de Neurnios Artificiais";
								JOptionPane.showMessageDialog(desktop, msg, titulo, 0);
							}
						}
				}	else {	// Sai do programa
				Imagem imagem = null;
				for (int i = 0; i < vecImagens.comprimento(); i++)	{
					imagem = (Imagem)vecImagens.elementoEm(i);
				}
				sair();
			}
  }		// end ActionPerformed

	//	Sai da aplicao
	//
  protected void sair() {
		System.exit(0);
  }

	// Encontra grupos com algoritmo heurstico leader
	//
	private void leader() {

		Imagem imagem = null;
		int altura, largura, indice, nBandas;
		boolean flag = true;

		// Array para armazenar variveis (bandas) e valores dos pixels:
		//	variavel[largura*altura][#bandas]
		//	linhas = #observaes = #pixels
		//	colunas = #variveis = #bandas
		//
		int variavel[][], temp[];

		// L primeira imagem para resgatar valores de altura e largura
		//
		imagem = (Imagem)vecImagens.elementoEm(ei.indiceImagensEscolhidas[0]);
		altura = imagem.retornaAltura();
		largura = imagem.retornaLargura();
		nBandas = ei.imagensEscolhidas.length;
		temp = new int[largura*altura];
		variavel = new int[largura*altura][nBandas];

		// L as imagens escolhidas e as transforma em vetores-colunas, pois cada
		// banda ser como uma varivel para o clculo dos K-grupos (K-clusters).
		//
		for (int k = 0; k < nBandas; k++)	{
			imagem = (Imagem)vecImagens.elementoEm(ei.indiceImagensEscolhidas[k]);
			temp = (int[])imagem.retornaVetorPixels();
			for (int i = 0; i < altura; i++)
				for (int j = 0; j < largura; j++) {

					// Pega pixels da banda k
					//
					indice = j + i*largura;
					variavel[indice][k] = temp[indice];
				}
		}

		// Libera rea de temp
		//
		temp = null;

		// n = #colunas = #variveis
		//
		int n = variavel[0].length;

		// m = #linhas = #objetos/observaes
		//
		int m = variavel.length;
		System.out.println("\n#variaveis = "+n+", "+"#obs.: "+m);

		// Sequencia para algoritmos leader e joiner 
		// Chamamos o leader, por ser mais rpido.
		// Usar o joiner somente para pequenas imagens, seno o tempo
		// de espera pode ser muito longo.
		//
		int grupos[] = new int[m];	// vetor com parties
		int n1, n2, nc;							// #clusters desejados. Modificar: n1 e n2
		int	delta,									// "dimetro" inicial do cluster (modificvel);
				rho;										// incrementos do "dimetro" do cluster

		// Faz primeiro cluster = n1
		//
		n1 = n2 = cluster.retornaGrupos();
		nc = n1;
		if (nc == 0)
			nc = 2;
		delta = cluster.retornaDiametro();
		System.out.println("#cluster: "+nc+", diametro = "+delta);
		rho = 0;
		do {
			rho += delta;
			grupos = cluster.leader(variavel, nc, rho);
			flag = true;
			
			for (int i = 0; i < m; i++) {
				if (grupos[i] == 0) {
					flag = false;
					break;					
				}
			}
			if (flag) {
				rho = 0;
				nc++;
			}
		} while (nc <= n2);

		// Libera rea das imagens
		//
		variavel = null;

		// Cria imagem com parties
		//
		String nomeImagem = imagem.retornaNomeArquivoImagem();
		criaImagemCluster(grupos, largura, altura, nomeImagem, "H");

		// Contabiliza #pixels por grupo
		//
		int[] nGrupos = new int[cluster.retornaGrupos()];
		for (int i = 0; i < m; i++)
			nGrupos[grupos[i]-1]++;
		
		System.out.println("Estatisticas: #pixels/grupo\n");
		double porcento;
		for (int i = 1; i <= cluster.retornaGrupos(); i++) {
			porcento = nGrupos[i-1]*100/(largura*altura);
			System.out.println("Grupo "+ i + ": "+ nGrupos[i-1] + 
													" pixels. (" + porcento + "%)");
		}

		// Libera rea de parties
		//
		grupos = null;
	}		// leader

	// Encontra grupos com k-mdias
	//
	private void calculaKmedias() {

		Imagem imagem = null;
		int altura, largura, nBandas, indice;

		// Array para armazenar variveis (bandas) e valores dos pixels:
		//	variavel[largura*altura][#bandas]
		//	linhas = #observaes = #pixels
		//	colunas = #variveis = #bandas
		//
		int variavel[][], temp[];

		// L primeira imagem para resgatar valores de altura e largura
		//
		imagem = (Imagem)vecImagens.elementoEm(ei.indiceImagensEscolhidas[0]);
		altura = imagem.retornaAltura();
		largura = imagem.retornaLargura();
		nBandas = ei.imagensEscolhidas.length;
		temp = new int[largura*altura];
		variavel = new int[largura*altura][nBandas];

		// L as imagens escolhidas e as transforma em vetores-colunas, pois cada
		// banda ser como uma varivel para o clculo dos K-grupos (K-clusters).
		//
		for (int k = 0; k < nBandas; k++)	{
			imagem = (Imagem)vecImagens.elementoEm(ei.indiceImagensEscolhidas[k]);
			temp = (int[])imagem.retornaVetorPixels();
			for (int i = 0; i < altura; i++)
				for (int j = 0; j < largura; j++) {

					// Pega pixels da banda k
					//
					indice = j + i*largura;
					variavel[indice][k] = temp[indice];
				}
		}

		// Libera rea de temp
		//
		temp = null;

		// n = #colunas = #variveis
		//
		int n = variavel[0].length;

		// m = #linhas = #objetos/observaes
		//
		int m = variavel.length;
		System.out.println("\n#variaveis = "+n+", "+"#obs.: "+m);

		// Sequencia para algoritmo k-mdias

		// Vetor com parties
		//
		int grupos[] = new int[m];

		// Parms usados no algoritmo
		//
    int n1, n2, idr = 0, ip = 0, k = 0;

		// Faz primeiro cluster = n1
		//
		n1 = n2 = cluster.retornaGrupos();

		for (int nc = n1; nc <= n2; nc++) {		
			if (ip == 0) {
				k = 0;
				for (int i = 0; i < m; i++) {	
					k++;
          if (k > nc)
						k = k - nc;
          grupos[i] = k;
				}	
			}	// if

			grupos = cluster.kMeans(variavel, grupos, nc, idr);
		}

		// Libera rea das imagens
		//
		variavel = null;

		// Cria imagem com parties
		//
		String nomeImagem = imagem.retornaNomeArquivoImagem();
		criaImagemCluster(grupos, largura, altura, nomeImagem, "K");

		// Contabiliza #pixels por grupo
		//
		int[] nGrupos = new int[cluster.retornaGrupos()];
		for (int i = 0; i < m ; i++)
			nGrupos[grupos[i]-1]++;

		System.out.println("Estatisticas: #pixels/grupo\n");
		double porcento;
		for (int i = 1; i <= cluster.retornaGrupos(); i++) {
			porcento = nGrupos[i-1]*100/(largura*altura);
			System.out.println("Grupo "+ i + ": "+ nGrupos[i-1] + 
													" pixels. (" + porcento + "%)");
		}

		// Libera rea de parties
		//
		grupos = null;
	}		// calculaKmedias

	// Encontra grupos com fuzzy c-mdias
	//
	private void calculaFuzzyCMedias() {

		Imagem imagem = null;
		int altura, largura, nBandas, indice, maxIter;
		double eps, mFuzzy;

		// Array para armazenar variveis (bandas) e valores dos pixels:
		//	variavel[largura*altura][#bandas]
		//	linhas = #observaes = #pixels
		//	colunas = #variveis = #bandas
		//
		int temp[];					
		double variavel[][];

		// L primeira imagem para resgatar valores de altura e largura
		//
		imagem = (Imagem)vecImagens.elementoEm(ei.indiceImagensEscolhidas[0]);
		altura = imagem.retornaAltura();
		largura = imagem.retornaLargura();
		nBandas = ei.imagensEscolhidas.length;
		temp = new int[largura*altura];

		variavel = new double[largura*altura][nBandas];

		// L as imagens escolhidas e as transforma em vetores-colunas, pois cada
		// banda ser como uma varivel para o clculo dos c-grupos (c-clusters).
		//
		for (int k = 0; k < nBandas; k++)	{
			imagem = (Imagem)vecImagens.elementoEm(ei.indiceImagensEscolhidas[k]);
			temp = (int[])imagem.retornaVetorPixels();
			for (int i = 0; i < altura; i++)
				for (int j = 0; j < largura; j++) {

					// Pega pixels da banda k
					//
					indice = j + i*largura;
					variavel[indice][k] = (double)temp[indice];
				}
		}

		// Libera rea de temp
		//
		temp = null;

		// n = #colunas = #variveis
		//
		int n = variavel[0].length;

		// m = #linhas = #objetos/observaes
		//
		int m = variavel.length;
		System.out.println("\n#variaveis = "+n+", "+"#obs.: "+m);

		// Seqncia para algoritmo fuzzy c-medias

		// Vetor com parties.
		//
		int grupos[] = new int[m+1];

		// Parms usados no algoritmo
		//
    int n1, n2, idr = 0, ip = 0, k = 0;

		// Faz primeiro cluster = n1
		//
		n1 = n2 = cluster.retornaGrupos();

		for (int nc = n1; nc <= n2; nc++) {
			if (ip == 0) {
				k = 0;
				for (int i = 0; i < m; i++) {
					k++;
          if (k > nc)
						k = k - nc;
          grupos[i] = k;
				}
			}	// if

			maxIter = cluster.retornaMaximoIteracoes();
			eps = cluster.retornaEpsilon();
			mFuzzy = cluster.retornaFuzziness();
			grupos = cluster.fuzzyCMeans(variavel, grupos, nc, maxIter, eps, mFuzzy);
		}

		// Libera rea das imagens
		//
		variavel = null;

		// Cria imagem com parties
		//
		String nomeImagem = imagem.retornaNomeArquivoImagem();
		criaImagemCluster(grupos, largura, altura, nomeImagem, "FCM");

		// Contabiliza #pixels por grupo
		// O nmero de grupos deve ser incrementado de 1, pois estamos
		// criando um grupo a mais para colocar os valores no "puros."
		//
		int[] nGrupos = new int[cluster.retornaGrupos()+1];
		for (int i = 0; i < m ; i++)
			nGrupos[grupos[i]-1]++;

		System.out.println("Estatisticas: #pixels/grupo\n");
		double porcento;
		for (int i = 1; i <= cluster.retornaGrupos()+1; i++) {
			porcento = nGrupos[i-1]*100/(largura*altura);
			System.out.println("Grupo "+ i + ": "+ nGrupos[i-1] + 
													" pixels. (" + porcento + "%)");
		}

		// Libera rea de parties
		//
		grupos = null;
	}		// calculaFuzzyCMedias

	private void criaImagemCluster(int[] clusters, int w, int h, 
		String nomeImg, String algoritmo) {

		int tipo, pixel, indice;
		
		tipo = BufferedImage.TYPE_3BYTE_BGR;
		BufferedImage out = new BufferedImage(w, h, tipo); 
    WritableRaster outWR = out.getRaster(); 

		for (int i = 0; i < h; i++) 
			for (int j = 0; j < w; j++) {
				indice = j + i*w;
				pixel = clusters[indice];
				switch (pixel) {
					case 1:
						outWR.setSample(j, i, 0, 255);
						outWR.setSample(j, i, 1, 0);
						outWR.setSample(j, i, 2, 0);
						break;
					case 2:
						outWR.setSample(j, i, 0, 0);
						outWR.setSample(j, i, 1, 255);
						outWR.setSample(j, i, 2, 0);
						break;
					case 3:
						outWR.setSample(j, i, 0, 0);
						outWR.setSample(j, i, 1, 0);
						outWR.setSample(j, i, 2, 255);
						break;
					case 4:
						outWR.setSample(j, i, 0, 255);
						outWR.setSample(j, i, 1, 0);
						outWR.setSample(j, i, 2, 255);
						break;
					case 5:
						outWR.setSample(j, i, 0, 0);
						outWR.setSample(j, i, 1, 255);
						outWR.setSample(j, i, 2, 255);
						break;
					case 6:
						outWR.setSample(j, i, 0, 255);
						outWR.setSample(j, i, 1, 255);
						outWR.setSample(j, i, 2, 0);
						break;
					case 7:
						outWR.setSample(j, i, 0, 128);
						outWR.setSample(j, i, 1, 0);
						outWR.setSample(j, i, 2, 255);
						break;
				}
			}

		// Salva a imagem no formato "png", que preserva os valores exatos acima.
		// O formato "jpg" acrescenta efeitos esprios s cores (valores) acima 
		// definidas. 
		//
		try	{

			// Recupera o nome da imagem, sem extenso
			//
			String search = ".";
			int i = nomeImg.indexOf(search);
			String prefixo = nomeImg.substring(0, i);
			prefixo += "_" + String.valueOf(cluster.retornaGrupos()) + algoritmo;
			System.out.println("Criando cluster imagem '" + prefixo 
													+ ".png' em C:\\temp\\");
			ImageIO.write(out, "png", new File("C:\\temp\\" + prefixo + ".png"));		
		} catch (IOException e) {
				System.out.println("Problema gravando arquivo imgCluster.");
        System.exit(0);
		}
	}

	/**
     * Cria a GUI e mostra.  Para segurana,
     * este mtodo deve ser chamado do "main," 
     * a thread inicial.
	  */

	private static void createAndShowGUI() {

		// Define janela decorada
		//
    JFrame.setDefaultLookAndFeelDecorated(true);

    // Cria e define a janela
		//
    SofiaImagens frame = new SofiaImagens();
    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		// Mostra a janela inicial
		//
    frame.setVisible(true);
  }

  public static void main(String[] args) {

		// Relaciona uma tarefa para lanar a thread:
    // cria e mostra a GUI
		//
    javax.swing.SwingUtilities.invokeLater(new Runnable() {
        public void run() {
          createAndShowGUI();
        }
    });
  }
}