/******************************************************************************
TipoArquivo.java

Direitos Autorais Reservados (c) 2009 Embrapa Informática Agropecuária

Este programa é software livre; você pode redistribuí-lo e/ou modificá-lo sob
os termos da Licença Pública Geral GNU conforme publicada pela Free Software
Foundation; tanto a versão 2 da Licença, como (a seu critério) qualquer versão
posterior.

Este programa é distribuído na expectativa de que seja útil, porém, SEM NENHUMA
GARANTIA; nem mesmo a garantia implícita de COMERCIABILIDADE OU ADEQUAÇÃO A UMA
FINALIDADE ESPECIFICA. Consulte a Licença Pública Geral do GNU para mais 
detalhes.

Você deve ter recebido uma cópia da Licença Pública Geral do GNU junto com este
programa; se não, escreva para a Free Software Foundation, Inc., no endereço 59
Temple Street, Suite 330, Boston, MA 02111-1307 USA.

********************************************************************************

Parte integrante do software 'Sofia Imagens - SOFtware Inteligente de Análise 
                                              de Imagens'.

Este fonte faz parte do livro:

	Processamento de Imagens Digitais: Métodos Multivariados em Java.
	José Iguelmar Miranda.
	Embrapa Informática Agropecuária.
	Campinas, maio de 2009.

Descrição:

	Classe para filtrar por extensão de arquivo.

Entrada:

	String com extensão a ser filtrada.

Saída:

 Void

Desenvolvido por:

    José Iguelmar Miranda

Informações do CVS:
       $Source$:
       $Revision$:
       $Date$:

******************************************************************************/

package pID;

// Pacote genérico
import java.io.File;

// Pacote Swing
import javax.swing.filechooser.FileFilter;

public class TipoArquivo extends FileFilter {

	// ATRIBUTOS

	String tipo;

	// CONSTRUTOR

	public TipoArquivo(String ext) {
		tipo = ext;
	}

	// Implementação do método abstrato 'accept' da classe FileFilter
	//
	public boolean accept(File f) {
		return f.isDirectory() || 
			f.getName().toLowerCase().endsWith(tipo);
  }
  
	// Implementação do método abstrato 'getDescription' da classe FileFilter
	//
	public String getDescription() {
		return tipo;
	}
}