/******************************************************************************
TipoImagem.java

Direitos Autorais Reservados (c) 2009 Embrapa Informtica Agropecuria

Este programa  software livre; voc pode redistribu-lo e/ou modific-lo sob
os termos da Licena Pblica Geral GNU conforme publicada pela Free Software
Foundation; tanto a verso 2 da Licena, como (a seu critrio) qualquer verso
posterior.

Este programa  distribudo na expectativa de que seja til, porm, SEM NENHUMA
GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU ADEQUAO A UMA
FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral do GNU para mais 
detalhes.

Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto com este
programa; se no, escreva para a Free Software Foundation, Inc., no endereo 59
Temple Street, Suite 330, Boston, MA 02111-1307 USA.

********************************************************************************

Parte integrante do software 'Sofia Imagens - SOFtware Inteligente de Anlise 
                                              de Imagens'.

Este fonte faz parte do livro:

	Processamento de Imagens Digitais: Mtodos Multivariados em Java.
	Jos Iguelmar Miranda.
	Embrapa Informtica Agropecuria.
	Campinas, maio de 2009.

Descrio:

	Criar uma instncia com os tipos de imagens permitidas para leitura.
  Filtros para imagens.
  Formatos aceitos: GIF, TIF, JPEG, JPG, PNG e BMP

Entrada:

	Void

Sada:

 Void

Desenvolvido por:

    Jos Iguelmar Miranda

Informaes do CVS:
       $Source$:
       $Revision$:
       $Date$:

******************************************************************************/

package pID;

// Pacotes genricos
import java.io.File;
import javax.swing.filechooser.FileFilter;

public class TipoImagem extends FileFilter {

  public boolean accept(File f) {
		if (f.isDirectory()) {
			return true;
		}

		String extension = getExtension(f);
		if (extension != null) {
			if (extension.equals("gif") ||
				extension.equals("tif") ||
				extension.equals("jpeg") ||
				extension.equals("jpg") ||
				extension.equals("png") ||
				extension.equals("bmp")) {
				return true;
			} else {
				return false;
			}
		}
		return false;
	}

	// Implementao requerida pelo FileFilter - mtodo abstract
	//
	public String getDescription() {
		return "gif, tif, jpeg, jpg, png, bmp";
	}

  private static String getExtension(File f) {
		String ext = null;
    String s = f.getName();
    int i = s.lastIndexOf('.');

    if (i > 0 &&  i < s.length() - 1) {
			ext = s.substring(i+1).toLowerCase();
    }
		return ext;
  }
}